<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="description" content="Webová aplikace pro správu vodoměru a ventilu - přehled">
<meta name="keywords" content="Správa vodoměru">
<meta name="author" content="Ladislav Hloušek">
<meta name="viewport" content="width=device-width, initial-scale=1.0">

<link rel="stylesheet" href="{{ url_for('static', filename='css/modal.css') }}">
<link rel="stylesheet" href="{{ url_for('static', filename='sbadmin/vendor/bootstrap/css/bootstrap.min.css') }}">
<link rel="stylesheet" href="{{ url_for('static', filename='sbadmin/vendor/metisMenu/metisMenu.min.css') }}">
<link rel="stylesheet" href="{{ url_for('static', filename='sbadmin/vendor/datatables-plugins/dataTables.bootstrap.css') }}">
<link rel="stylesheet" href="{{ url_for('static', filename='sbadmin/vendor/datatables-responsive/dataTables.responsive.css') }}">
<link rel="stylesheet" href="{{ url_for('static', filename='sbadmin/dist/css/sb-admin-2.css') }}">
<link rel="stylesheet" href="{{ url_for('static', filename='sbadmin/vendor/font-awesome/css/font-awesome.min.css') }}" type="text/css">
<link rel="stylesheet" href="{{ url_for('static', filename='fullcalendar/fullcalendar.min.css') }}" type="text/css">
<link rel="stylesheet" href="{{ url_for('static', filename='fullcalendar/fullcalendar.print.min.css') }}" type="text/css" media='print'>
<link rel="stylesheet" href="{{ url_for('static', filename='datetimepicker/css/bootstrap-datetimepicker.min.css') }}" type="text/css">

<title>Fengoo - WATER GUARD</title>

<style>
#kalendar {
    max-width: 100%;
    margin: 0 auto;
  }
</style>
</head>

<body>
<div id="wrapper">
	<!-- Navigation -->
    <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
		<div class="navbar-header">
			<button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
				<span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="/">
				<img style="display: inline; width: 150px;" src="{{ url_for('static', filename='images/logo.png') }}" alt="logo" title="Logo"/> - WATER GUARD
			</a>
        </div>
		<!-- /.navbar-header -->
		
		<ul class="nav navbar-top-links navbar-left">
			            
		</ul>
		
		<div class="navbar-default sidebar" role="navigation">
			<div class="sidebar-nav navbar-collapse">
				<ul class="nav" id="side-menu">
					<li>
						<a href="/"><i class="fa fa-dashboard fa-fw"></i> Přehled</a>
					</li>
					<li class="active">
						<a href="/kalendar"><i class="fa fa-calendar fa-fw"></i> Kalendář</a>
					</li>
					<li>
						<a href="/historie"><i class="fa fa-history fa-fw"></i> Historie</a>
					</li>
					<li>
						<a href="/stats"><i class="fa fa-bar-chart fa-fw"></i> Statistiky</a>
					</li>
					<li>
						<a href="/nastaveni"><i class="fa fa-wrench fa-fw"></i> Nastavení</a>
					</li>
					<li>
						<a id="logoutBtn" href="#"><i class="fa fa-sign-out fa-fw"></i> Odhlásit</a>
					</li>
				</ul>
				<p style="text-align:center;">Verze: <span id="ver"></span></p>
				<p style="text-align:center;">© 2016-2022 NetVoice, s.r.o. All rights reserved</p>
			</div>
			<!-- /.sidebar-collapse -->
		</div>
		<!-- /.navbar-static-side -->
    </nav>
	
	<!-- Page Content -->
	<div id="page-wrapper">
		<div class="container-fluid">
			<div class="row">
				<div class="col-xs-12">
					<h1 class="page-header">Kalendář</h1>
				</div>
				<!-- /.col-lg-12 -->
			</div>
			<!-- /.row -->
			
			
			<div class="row">
				<div class="col-lg-12 col-md-12 col-xs-12">
          <div class="flashes" style="margin-bottom: 10px;">
							{% with messages = get_flashed_messages(with_categories=true) %}
								{% if messages %}
									{% for category,message in messages %}
										{% if category != "warning" %}
										<div class="alert alert-{{ category }}">
										{{ message }}
										</div>
										{% endif %}
									{% endfor %}
								{% endif %}
							{% endwith %}
          </div>
        </div>
			</div>
      <div class="row">
        <div class="col-lg-12 col-md-12 col-xs-12">
          <div id="kalendar" />
        </div>
      </div>
			<!-- /.row -->
      
		</div>
		<!-- /.container-fluid -->
	</div>
	<!-- /#page-wrapper -->
</div>

<div class="modal fade" id="eventModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title title" id="myModalLabel">Nová událost</h4>
      </div>
      <div class="modal-body">
        <div class="row">
          <form id="frmSaveEvent" action="/saveEvent" method="POST">
          <div class="form-group col-lg-12 col-md-12 col-xs-12">
            <label>Název</label>
            <input  name="eventNazev" class="form-control title eventVal" type="text" id="eventNazev" />
            <p class="help-block">Název události</p>
          </div>
          
          <div class="form-group col-lg-6 col-md-6 col-xs-12">
            <label>Start</label>
            <input name="eventStart" class="form-control date eventVal" type="text" id="eventStart" />
            <p class="help-block">Datum a čas spuštění události</p>
          </div>
          <div class="form-group col-lg-6 col-md-6 col-xs-12">
            <label>Konec</label>
            <input name="eventKonec" class="form-control date eventVal" type="text" id="eventKonec" />
            <p class="help-block">Datum a čas ukončení události</p>
          </div>          
          <div class="form-group col-lg-6 col-md-6 col-xs-12">
            <label>Akce - start</label>
            <select name="eventStartAkce" class="form-control eventVal" id="eventStartAkce">
              <option value="0">Bez akce</option>
              <option value="1">Zavřít ventil</option>
              <option value="2">Otevřít ventil</option>
              <option value="3">Otevřít ventil s limitem</option>
            </select>
            <p class="help-block">Akce se provede na začátku události</p>
          </div>
          <div class="form-group col-lg-6 col-md-6 col-xs-12">
            <label>Akce - konec</label>
            <select name="eventKonecAkce" class="form-control eventVal" id="eventKonecAkce">
              <option value="0">Bez akce</option>
              <option value="1">Zavřít ventil</option>
              <option value="2">Otevřít ventil</option>
              <option value="3">Otevřít ventil s limitem</option>
            </select>
            <p class="help-block">Akce se provede na konci události</p>
          </div>
		  
		  <div class="form-group col-lg-6 col-md-6 col-xs-12 limitGroup">
            <label>Jednotka limitu</label>
            <select name="eventLimitJed" class="form-control eventVal" id="eventLimitJed">
			  <option value="0">bez limitu</option>
              <option value="1">litry</option>
              <option value="2">hodiny</option>
			  <option value="3">minuty</option>              
			  <option value="4">Průtok litry/hodinu</option>
              <option value="5">Průtok litry/minutu</option>
            </select>
            <p class="help-block">Jednotka pro limit průtoku</p>
          </div>
          <div class="form-group col-lg-6 col-md-6 col-xs-12 limitGroup">
            <label>Limit</label>
            <input name="eventLimit" class="form-control eventVal" type="text" id="eventLimit" />
            <p class="help-block">Hodnota limitu</p>
          </div>
		  		  
		  <div class="form-group col-lg-6 col-md-6 col-xs-12">
		  <label>Opakovat</label>
			<select name="eventRepeat" class="form-control eventVal" id="eventRepeat">
				<option value="none" selected>Žádné opakování</option>
				<option value="everyD">Denně</option>
				<option value="everyW">Týdně</option>
				<option value="everyM">Měsíčně</option>
				<option value="everyY">Ročně</option>
				<option value="everyWD">Každý pracovní den</option>
			</select>
            <p class="help-block">Typ opakování události</p>
		  </div>
		  
          </form>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" id="close" data-dismiss="modal">Zavřít</button>
        <button type="button" class="btn btn-danger" id="delete" data-dismiss="modal">Smazat</button>
        <input type="submit" class="btn btn-primary" value="Uložit" id="save" />
      </div>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>

<script src="{{ url_for('static', filename='sbadmin/vendor/jquery/jquery.min.js') }}"></script>
<!-- Bootstrap Core JavaScript -->
<script src="{{ url_for('static', filename='sbadmin/vendor/bootstrap/js/bootstrap.min.js') }}"></script>
<!-- Metis Menu Plugin JavaScript -->
<script src="{{ url_for('static', filename='sbadmin/vendor/metisMenu/metisMenu.min.js') }}"></script>
<!-- DataTables JavaScript -->
<script src="{{ url_for('static', filename='sbadmin/vendor/datatables/js/jquery.dataTables.min.js') }}"></script>
<script src="{{ url_for('static', filename='sbadmin/vendor/datatables-plugins/dataTables.bootstrap.min.js') }}"></script>
<script src="{{ url_for('static', filename='sbadmin/vendor/datatables-responsive/dataTables.responsive.js') }}"></script>
<!-- Custom Theme JavaScript -->
<script src="{{ url_for('static', filename='sbadmin/dist/js/sb-admin-2.js') }}"></script>
<script src="{{ url_for('static', filename='js/moment.js') }}"></script>
<script src="{{ url_for('static', filename='fullcalendar/fullcalendar.min.js') }}"></script>
<script src="{{ url_for('static', filename='fullcalendar/locale-all.js') }}"></script>
<script src="{{ url_for('static', filename='datetimepicker/js/bootstrap-datetimepicker.min.js') }}"></script>


<script>
var selectedEvent = {};
var isNew = false;
var dtFormat = 'DD.MM.YYYY HH:mm';
var events = [];

moment.locale('cs');

function isEmpty(obj) {
    for(var key in obj) {
        if(obj.hasOwnProperty(key))
            return false;
    }
    return true;
}

$.prototype.enable = function () {
    $.each(this, function (index, el) {
        $(el).removeAttr('disabled');
    });
}

$.prototype.disable = function () {
    $.each(this, function (index, el) {
        $(el).attr('disabled', 'disabled');
    });
}

function findEvent(event)
{
  var item = events.find(item => item.id === event.id);
  return item;
}

$(document).ready(function(){
  
  $.getJSON("/version", {}, function(data) {
		$("#ver").html(data);
  });
	
  loadMainCalendar();
  
  $("#kalendar").fullCalendar('rerenderEvents');
  
//$("#logoutBtn").click(function(){
//		if(confirm("Opravdu se chcete odhlásit?")) {
//			location.href ="/logout";
//		}
//	});

	$(".alert").fadeTo(3500, 600).slideUp(400, function () {
		$(".alert").slideUp(600);
		$(".alert").remove();
	
  });
  
  $("#close").click(function(){
    if(isEmpty(selectedEvent) || selectedEvent.isNew)
		addEventClose();
    
    selectedEvent = {};
  });
  
  $("#delete").click(function(){
	if(confirm("Opravdu chcete smazat tuto událost?")){
		if(!isEmpty(selectedEvent))
		{
		  if(!selectedEvent.isNew)
			removeEvent(selectedEvent.id); 
		}
	}
	
	addEventClose();
	selectedEvent = {};
  });
  
  $('#eventStart').on('dp.change', function(x) {
		var d = $('#eventStart').data("DateTimePicker").date();
		if(!isEmpty(selectedEvent))
			selectedEvent.start = d;
			//console.log(selectedEvent);
	});
	
	$('#eventKonec').on('dp.change', function(x) {
		var d = $('#eventKonec').data("DateTimePicker").date();
		if(!isEmpty(selectedEvent))
			selectedEvent.end = d;
			//console.log(selectedEvent);			
	});
	
  $("#frmSaveEvent").submit(function(e) {
    console.log(e);
    console.log($(this).serializeArray());
    e.preventDefault();
  });
  
  $("#save").click(function(){
    if(!isEmpty(selectedEvent))
    {
      if(selectedEvent.isNew)
      {
        selectedEvent.canDelete = true;
        events.push(selectedEvent);
      }
	  
      data = {
        id: selectedEvent.id,
        title: selectedEvent.title,
        start: selectedEvent.start.utcOffset(0,true).format(),
        end: selectedEvent.end.utcOffset(0,true).format(),
        allDay: selectedEvent.allDay,
        eventStartAkce: selectedEvent.eventStartAkce,
        eventKonecAkce: selectedEvent.eventKonecAkce,
		eventLimitJed: selectedEvent.eventLimitJed,
		eventLimit: selectedEvent.eventLimit,
		eventRepeat: selectedEvent.eventRepeat
      };
      
	  $("#kalendar").fullCalendar('renderEvent', selectedEvent, false);
      saveEvent(data);

    }
    $('#eventModal').modal('hide');
	});
  
  $('.date').datetimepicker({
    locale: 'cs',
    format: dtFormat,
  });
});

function loadMainCalendar(dw = 'month')
{
  $("#kalendar").fullCalendar({
    locale: 'cs',
    defaultView: 'month',
    header: {
      left: 'prev,next today',
      center: 'title',
      right: ''
    },
    timeFormat: 'H:mm',
    displayEventTime: true,
    displayEventEnd: true,
    editable: true,        
    selectable: true,
    selectHelper: true,
    allDay: false,
    unselectAuto: true,
    forceEventDuration: true,
    select: function(start,end) {
      var alldayV = false;
      if(start.hour() == 0 && start.minute() == 0 && end.hour() == 0 && end.minute() == 0)
      {
        alldayV = true;
      }
      
      var eventData = {
        title: "Nová událost",
        start: start,
        end: end,
        backgroundColor: "#999999",
        borderColor: "#999999",
        textColor: "#ffffff",
        canDelete: false,
        canEdit: true,
        allDay: false,
        eventStartAkce: 0,
        eventKonecAkce: 0,
		eventLimitJed: 0,
		eventLimit: 0,
		isNew: true,
		stavVentil: "0",
		eventRepeat: "none"
      };
      
      eventModal(eventData);
	  //console.log("select", eventData);
    },
    eventClick: function(event, jsEvent, view) {
      selectedEvent = {}
      selectedEvent = event;
	  eventModal(selectedEvent);  
    },
    eventRender: function(event, element, view) {
	
		if(event.eventRepeat == "everyD")
		{
			let dtnow = moment();
			let cpyEvent = event;
			
			cpyEvent.start.day = dtnow.day;
			cpyEvent.start.day = dtnow.day;			
			cpyEvent.start.month = dtnow.month;
			cpyEvent.start.month = dtnow.month;
			cpyEvent.start.year = dtnow.year;
			cpyEvent.start.year = dtnow.year;
			
			cpyEvent.end.day = dtnow.day;
			cpyEvent.end.day = dtnow.day;
			cpyEvent.end.month = dtnow.month;
			cpyEvent.end.month = dtnow.month;			
			cpyEvent.end.year = dtnow.year;
			cpyEvent.end.year = dtnow.year;
			
			event.dow = [0,1,2,3,4,5,6];
		}
		
		if(event.eventRepeat == "everyM")
		{
			var dt_now = moment();
			if(dt_now.month != event.start.month)
			{
				
			}
		}		
		
		if(event.eventRepeat == "everyW")
		{
		
		}
		
		if(event.eventRepeat == "everyY")
		{
		}
		
		if(event.eventRepeat == "everyWD")
		{
		}
    },
	eventSources: [
		{
			url: '/loadEvents'
		}
	]
  });
}

function eventModal(event, edit=false)
{
    var e = event;
        
    $(".title").val(e.title);
	
	//$('#eventStart').data("DateTimePicker").date(e.start);
	$('#eventStart').val(e.start.format(dtFormat));
    //$('#eventKonec').data("DateTimePicker").date(e.end);
    $('#eventKonec').val(e.end.format(dtFormat));
    
	$('#eventStartAkce option[value=\"'+e.eventStartAkce+'\"]').attr('selected','selected');
			
	$('#eventKonecAkce option[value=\"'+e.eventKonecAkce+'\"]').attr('selected','selected');
	$('#eventStartAkce').val(e.eventStartAkce);
	$('#eventKonecAkce').val(e.eventKonecAkce);
    
	
	$('#eventRepeat option[value=\"'+e.eventRepeat+'\"]').attr('selected','selected');
	
	if(e.eventLimitJed !== "" && e.eventLimit !== "")
	{	
		$('#eventLimitJed option[value=\"'+e.eventLimitJed+'\"]').attr('selected','selected');
		$('#eventLimit').val(e.eventLimit);
	}
		
    setEvent(e);
    selectedEvent = {}
    selectedEvent = e;
    
    $('#eventModal').modal('show');
}

function setEvent(e)
{
  var now = moment();
  if(e.end < now)
  {
    e.canDelete = false;
    e.canEdit = false;
  } else {
	e.canDelete = true;
	e.canEdit = true;
  }
  
  if(e.canDelete)
  {
    $("#delete").css("display","inline-block");
  } else {
    $("#delete").css("display","none");
  }
    
  if(e.canEdit)
  {
    $('#eventNazev').enable();
    $('#eventStart').enable();
    $('#eventKonec').enable();
    $('#eventStartAkce').enable();
    $('#eventKonecAkce').enable();
    $('#save').enable();
	$('#eventLimitJed').enable();
    $('#eventLimit').enable();
	$('#eventRepeat').enable();
	
	$(".eventVal").change(function(){
		var id = $(this).attr("id");
		console.log(id);
		
		if(!isEmpty(selectedEvent))
		{
			if(id === "eventNazev")
			{
				selectedEvent.title = $(this).val();
			}
			if(id === "eventStartAkce")
			{
				selectedEvent.eventStartAkce = $(this).val();
			}
			if(id === "eventKonecAkce")
			{
				selectedEvent.eventKonecAkce = $(this).val();
			}
			if(id === "eventLimitJed")
			{
				selectedEvent.eventLimitJed = $(this).val();
			}
            if(id === "eventLimit")
            {
                selectedEvent.eventLimit = $(this).val();
            }
			if(id === "eventRepeat")
            {
                selectedEvent.eventRepeat = $(this).val();
            }
        }
    });

   } else {
    $('#eventNazev').disable();
    $('#eventStart').disable();
    $('#eventKonec').disable();
    $('#eventStartAkce').disable();
    $('#eventKonecAkce').disable();
    $('#eventLimitJed').disable();
    $('#eventLimit').disable();
	$('#eventRepeat').disable();
    $('#save').disable();
   }
}

function saveEvent(eventData)
{
  console.log(eventData);
  $.ajax({
    url: '/saveEvent',
    data: JSON.stringify(eventData),
    type: 'POST',
    contentType: "application/json",
    dataType: "json",
    success: function(response) {
      console.log("res",response);
      $("#kalendar").fullCalendar('refetchEvents');
      $('#eventNazev').val("");
      $('#eventStart').val("");
      $('#eventKonec').val("");
      $('#eventStartAkce').val("0");
      $('#eventKonecAkce').val("0");
      $('#eventLimitJed').val("0");
      $('#eventLimit').val("0");
	  $('#eventRepeat').val("none");
      //location.href = "/kalendar";
	  if(response["Repeat"] != "none")
	  {
		if(response["Repeat"] == "everyD")
		{
		}
		
	  }
    },
    error: function(error) {
      console.log("error",error);
    }
  });
}

function removeEvent(eventId)
{
  //console.log("eId",eventId);
  $.ajax({
    url: '/removeEvent',
    data: JSON.stringify({id: eventId}),
    type: 'POST',
    contentType: "application/json",
    dataType: "json",
    success: function(response) {
      //console.log("res",response);
      $("#kalendar").fullCalendar('refetchEvents');
    },
    error: function(error) {
      console.log("error",error);
    }
  });
}

function addEventClose()
{
    var gView = $("#kalendar").fullCalendar('getView');
    var calendarStart = "";
    
    $("#kalendar").fullCalendar('destroy');
    loadMainCalendar();
    
    if (gView.name == "month" && gView.start.date() > 20)
    {
        var cStart = gView.start;
        cStart.date(1);
        cStart.add(1, 'M');
        calendarStart = cStart.format("YMMDD");
    } else {
        calendarStart = gView.start.format("YMMDD");
    }
    
    $("#kalendar").fullCalendar('gotoDate', calendarStart);
    $("#kalendar").fullCalendar('changeView', "month");
    //$("#kalendar").fullCalendar('refetchEvents');
}
</script>
<script src="{{ url_for('static', filename='js/modalLogout.js') }}"></script>
</body>

</html>
